function varargout = cc_guiMainFrame(varargin)
% CC_GUIMAINFRAME M-file for cc_guiMainFrame.fig
%      CC_GUIMAINFRAME, by itself, creates a new CC_GUIMAINFRAME or
%      raises the existing
%      singleton*.
%
%      H = CC_GUIMAINFRAME returns the handle to a new CC_GUIMAINFRAME or the handle to
%      the existing singleton*.
%
%      CC_GUIMAINFRAME('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CC_GUIMAINFRAME.M with the given input arguments.
%
%      CC_GUIMAINFRAME('Property','Value',...) creates a new CC_GUIMAINFRAME or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before cc_guiMainFrame_OpeningFunction gets
%      called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to cc_guiMainFrame_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLESc

% Edit the above text to modify the response to help cc_guiMainFrame

% Last Modified by GUIDE v2.5 07-Apr-2009 23:32:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @cc_guiMainFrame_OpeningFcn, ...
                   'gui_OutputFcn',  @cc_guiMainFrame_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before cc_guiMainFrame is made visible.
function cc_guiMainFrame_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to cc_guiMainFrame (see VARARGIN)

% Computes coordinates of a GUI object such that it is in the center
cc_guiCenter(hObject)

% Choose default command line output for cc_guiMainFrame
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes cc_guiMainFrame wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% % Initializing Parameters
set(handles.edit3,'string',evalin('base','COMES_wrkspc.convctrl.InputPrm.error'));
set(handles.edit1,'string',evalin('base','COMES_wrkspc.convctrl.InputPrm.phi'));
set(handles.edit2,'string',evalin('base','COMES_wrkspc.convctrl.InputPrm.w'));
% set(handles.edit5,'string',evalin('base','COMES_wrkspc.convctrl.InputPrm.'));
% set(handles.edit6,'string',evalin('base','COMES_wrkspc.convctrl.InputPrm.'));


%Initialize the graphics ...
if (~isempty(evalin('base','COMES_wrkspc.System.Model.numg')) == 1 || ~isempty(evalin('base','COMES_wrkspc.System.Model.deng')) == 1)
    
    %The frequency response of Plant will be calculated below.
    evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
    %The blue curve is given as the Bode Diagram of the Nominal Plant.
    axes(handles.axes1)
    semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2),grid
    xlabel('Frequency (rad/sec)')
    ylabel('Magnitude (dB)')
    evalin('base','hold on')
    axes(handles.axes2)
    semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2),grid
    xlabel('Frequency (rad/sec)')
    ylabel('Phase (deg)')
    evalin('base','hold on')
    
else
    
    %Initialize the Bode Plots.
    %Magnitude
    axes(handles.axes1)
    xlabel('Frequency (rad/sec)')
    ylabel('Magnitude (dB)')
    %Phase
    axes(handles.axes2)
    xlabel('Frequency (rad/sec)')
    ylabel('Phase (deg)')
    
    warndlg('You must firstly enter the transfer function of the system.','Warning','modal')
    
    return  
end

if evalin('base','COMES_wrkspc.convctrl.TypeOfController == 1')
    %Checks for reminding of that which is used now.
    set(handles.Untitled_6,'Check','On')
    set(handles.Untitled_7,'Check','Off')
    set(handles.Untitled_8,'Check','Off')
    set(handles.Untitled_9,'Check','Off')
    set(handles.Untitled_10,'Check','Off')
    %
    set(handles.popupmenu1,'Enable','On');
    set(handles.edit3,'Enable','On');
    set(handles.slider4,'Enable','Off');    
    set(handles.edit5,'Enable','Off');
    set(handles.edit6,'Enable','Off');
elseif evalin('base','COMES_wrkspc.convctrl.TypeOfController == 2')
    %Checks for reminding of that which is used now.
    set(handles.Untitled_6,'Check','Off')
    set(handles.Untitled_7,'Check','On')
    set(handles.Untitled_8,'Check','Off')
    set(handles.Untitled_9,'Check','Off')
    set(handles.Untitled_10,'Check','Off')
    %
    set(handles.popupmenu1,'Enable','On');
    set(handles.edit3,'Enable','On');
    set(handles.slider4,'Enable','Off');
    set(handles.edit5,'Enable','Off');
    set(handles.edit6,'Enable','Off');
elseif evalin('base','COMES_wrkspc.convctrl.TypeOfController == 3')
    %Checks for reminding of that which is used now.
    set(handles.Untitled_6,'Check','Off')
    set(handles.Untitled_7,'Check','Off')
    set(handles.Untitled_8,'Check','On')
    set(handles.Untitled_9,'Check','Off')
    set(handles.Untitled_10,'Check','Off')
    %
    set(handles.popupmenu1,'Enable','Off');
    set(handles.edit3,'Enable','Off');
    set(handles.slider4,'Enable','Off');
    set(handles.edit5,'Enable','Off');
    set(handles.edit6,'Enable','Off');
elseif evalin('base','COMES_wrkspc.convctrl.TypeOfController == 4')
    %Checks for reminding of that which is used now.
    set(handles.Untitled_6,'Check','Off')
    set(handles.Untitled_7,'Check','Off')
    set(handles.Untitled_8,'Check','Off')
    set(handles.Untitled_9,'Check','On')
    set(handles.Untitled_10,'Check','Off')
    %
    set(handles.popupmenu1,'Enable','Off');
    set(handles.edit3,'Enable','Off');
    set(handles.slider4,'Enable','Off');
    set(handles.edit5,'Enable','Off');
    set(handles.edit6,'Enable','Off');
elseif evalin('base','COMES_wrkspc.convctrl.TypeOfController == 5')
    %Checks for reminding of that which is used now.
    set(handles.Untitled_6,'Check','Off')
    set(handles.Untitled_7,'Check','Off')
    set(handles.Untitled_8,'Check','Off')
    set(handles.Untitled_9,'Check','Off')
    set(handles.Untitled_10,'Check','On')
    %
    set(handles.popupmenu1,'Enable','Off');
    set(handles.edit3,'Enable','Off');
    set(handles.slider4,'Enable','On');
    set(handles.edit5,'Enable','On');
    set(handles.edit6,'Enable','On');
end


% --- Outputs from this function are returned to the command line.
function varargout = cc_guiMainFrame_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


%get the string for the editText component
sliderValue = get(handles.edit1,'String');

%convert from string to number
sliderValue = str2num(sliderValue);

%if user inputs something is not a number, or if the input is less than 0
%or great than 100, then the slider defaults to 0
if (isempty(sliderValue) || sliderValue < 0 || sliderValue > 180) 
    set(handles.slider1,'Value',0);
    set(handles.edit1,'String','0');
else
    set(handles.slider1,'Value',sliderValue);
end
guidata(hObject, handles);

var1 = get(handles.edit1,'String');
evalin('base',strcat('COMES_wrkspc.convctrl.InputPrm.phi =',var1,';'));


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double

var2 = get(handles.edit2,'String');
evalin('base',strcat('COMES_wrkspc.convctrl.InputPrm.w =',var2,';'));

% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


%obtains the slider value from the slider component
sliderValue = get(handles.slider1,'Value');

%puts the slider value into the edit text component
set(handles.edit1,'String', num2str(sliderValue));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Initialize the graphics ...
if (~isempty(evalin('base','COMES_wrkspc.System.Model.numg')) == 0 || ~isempty(evalin('base','COMES_wrkspc.System.Model.deng')) == 0)
    
    warndlg('You must firstly enter the transfer function of the system.','Warning','modal')
    
    return 
    
end

var1 = get(handles.edit1,'String');
evalin('base',strcat('COMES_wrkspc.convctrl.InputPrm.phi =',var1,';'));

if evalin('base','COMES_wrkspc.convctrl.TypeOfController == 1')
    
    if evalin('base','COMES_wrkspc.convctrl.InputPrm.ErrorType == 0') %Position error constant (Kp) ...
        % ...
        evalin('base','[COMES_wrkspc] = SystemTypeAnalyzer(COMES_wrkspc);') % degistir ...
        if evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 0') %For Type 0 systems ...

            if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0 | ... % %%%%
                    ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.error')) == 0)
                errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
                    'Error','modal')
                return
            else
                %The controller parameters of Lead Compensator will be calculated below
                evalin('base','[COMES_wrkspc] = LeadCompensatorSynthesis(COMES_wrkspc);')
    
                %The frequency response of Plant will be calculated below.
                evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')  
                
                %The blue curve is given as the Bode Diagram of the Nominal Plant.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Magnitude (dB)')
                evalin('base','hold on')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Phase (deg)')
                evalin('base','hold on')
    
                %The frequency response of Loop Gain will be calculated below.
                evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
                %The red curve is given as the Bode Diagram of the Loop Gain.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
                evalin('base','hold off')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
                 evalin('base','hold off')
    
                %Transfer Function of controller will be appeared in the text box.   
                set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kc')),'(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau')),'s','+','1',')'))
                set(handles.text10,'string',strcat('(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.alpha')),'s','+','1',')'))
            end
        elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 1') %For Type 1 Systems ...
            errordlg('The static position error must be equal to 0.','Error','modal')
            return
        else                                                   %For Type 2 or higher Systems ...
            errordlg('The static position error must be equal to 0.','Error','modal')
            return
        end
    elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.ErrorType == 1') %Static velocity constant (Kv) ...
        % ...
        evalin('base','[COMES_wrkspc] = SystemTypeAnalyzer(COMES_wrkspc);')
        if evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 0') %For Type 0 Systems ...
            errordlg('The static velocity error must be equal to 0.','Error','modal')
            return
        elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 1') %For Type 1 Sytems ...
            
            if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0 | ... % %%%%
                    ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.error')) == 0)
                errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
                    'Error','modal')
                return
            else
                %The controller parameters of Lead Compensator will be calculated below
                evalin('base','[COMES_wrkspc] = LeadCompensatorSynthesis(COMES_wrkspc);')
    
                %The frequency response of Plant will be calculated below.
                evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
                %The blue curve is given as the Bode Diagram of the Nominal Plant.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Magnitude (dB)')
                evalin('base','hold on')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Phase (deg)')
                evalin('base','hold on')
    
                %The frequency response of Loop Gain will be calculated below.
                evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
                %The red curve is given as the Bode Diagram of the Loop Gain.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
                evalin('base','hold off')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
                evalin('base','hold off')
    
                %Transfer Function of controller will be appeared in the text box.   
                set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kc')),'(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau')),'s','+','1',')'))
                set(handles.text10,'string',strcat('(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.alpha')),'s','+','1',')'))
            end
        else
            errordlg('The static velocity error must be equal to inf.','Error','modal') %For Type 2 or higher Systems ...
            return
        end
        
    elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.ErrorType == 2') %Static Acceleration Error (Ka) ...
        % ...
        evalin('base','[COMES_wrkspc] = SystemTypeAnalyzer(COMES_wrkspc);')
        if evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 0') %For Type 0 Systems ...
            errordlg('The static acceleration error must be equal to inf.','Error','modal')
            return
        elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 1') %For Type 1 Systems ...
            errordlg('The static acceleration error must be equal to inf.','Error','modal')
            return
        else                                                   %For Type 2 or higher Sytems ...

            if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0 | ... % %%%%
                    ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.error')) == 0)
                errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
                    'Error','modal')
                return
            else
                %The controller parameters of Lead Compensator will be calculated below
                evalin('base','[COMES_wrkspc] = LeadCompensatorSynthesis(COMES_wrkspc);')
    
                %The frequency response of Plant will be calculated below.
                evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
                %The blue curve is given as the Bode Diagram of the Nominal Plant.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Magnitude (dB)')
                evalin('base','hold on')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Phase (deg)')
                evalin('base','hold on')
    
                %The frequency response of Loop Gain will be calculated below.
                evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
                %The red curve is given as the Bode Diagram of the Loop Gain.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
                evalin('base','hold off')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
                evalin('base','hold off')
    
                %Transfer Function of controller will be appeared in the text box.   
                set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kc')),'(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau')),'s','+','1',')'))
                set(handles.text10,'string',strcat('(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.alpha')),'s','+','1',')'))
            end
        end
    end
end

if evalin('base','COMES_wrkspc.convctrl.TypeOfController == 2')
    
    if evalin('base','COMES_wrkspc.convctrl.InputPrm.ErrorType == 0') %Position error constant (Kp) ...
        % ...
        evalin('base','[COMES_wrkspc] = SystemTypeAnalyzer(COMES_wrkspc);')
        if evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 0') %For Type 0 systems ...
            
            if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0 | ... % %%%%
                    ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.error')) == 0)
                errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
                    'Error','modal')
                return
            else
                %The controller parameters of Lag Compensator will be calculated below
                evalin('base','[COMES_wrkspc] = LagCompensatorSynthesis(COMES_wrkspc);')

                %The frequency response of Plant will be calculated below.
                evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
                %The blue curve is given as the Bode Diagram of the Nominal Plant.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Magnitude (dB)')
                evalin('base','hold on')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Phase (deg)')
                evalin('base','hold on')
    
                %The frequency response of Loop Gain will be calculated below.
                evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
                %The red curve is given as the Bode Diagram of the Loop Gain.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
                evalin('base','hold off')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
                evalin('base','hold off')
    
                %Transfer Function of controller will be appeared in the text box.   
                set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kc')),'(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau')),'s','+','1',')'))
                set(handles.text10,'string',strcat('(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.beta')),'s','+','1',')'))
            end
        elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 1') %For Type 1 Systems ...
            errordlg('The static position error must be equal to 0.','Error','modal')
            return
        else                                                   %For Type 2 or higher Systems ...
            errordlg('The static position error must be equal to 0.','Error','modal')
            return
        end
    elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.ErrorType == 1') %Static velocity constant (Kv) ...
        % ...
        evalin('base','[COMES_wrkspc] = SystemTypeAnalyzer(COMES_wrkspc);')
        if evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 0') %For Type 0 Systems ...
            errordlg('The static velocity error must be equal to 0.','Error','modal')
            return
        elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 1') %For Type 1 Sytems ...
            
            if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0 | ... % %%%%
                    ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.error')) == 0)
                errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
                    'Error','modal')
                return
            else
                %The controller parameters of Lag Compensator will be calculated below
                evalin('base','[COMES_wrkspc] = LagCompensatorSynthesis(COMES_wrkspc);')
    
                %The frequency response of Plant will be calculated below.
                evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
                %The blue curve is given as the Bode Diagram of the Nominal Plant.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Magnitude (dB)')
                evalin('base','hold on')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Phase (deg)')
                evalin('base','hold on')
    
                %The frequency response of Loop Gain will be calculated below.
                evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
                %The red curve is given as the Bode Diagram of the Loop Gain.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
                evalin('base','hold off')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
                evalin('base','hold off')
    
                %Transfer Function of controller will be appeared in the text box.   
                set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kc')),'(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau')),'s','+','1',')'))
                set(handles.text10,'string',strcat('(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.beta')),'s','+','1',')'))
            end
        else
            errordlg('The static velocity error must be equal to inf.','Error','modal') %For Type 2 or higher Systems ...
            return
        end
        
    elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.ErrorType == 2') %Static Acceleration Error (Ka) ...
        % ...
        evalin('base','[COMES_wrkspc] = SystemTypeAnalyzer(COMES_wrkspc);')
        if evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 0') %For Type 0 Systems ...
            errordlg('The static acceleration error must be equal to inf.','Error','modal')
            return
        elseif evalin('base','COMES_wrkspc.convctrl.InputPrm.SystemType == 1') %For Type 1 Systems ...
            errordlg('The static acceleration error must be equal to inf.','Error','modal')
            return
        else                                                   %For Type 2 or higher Sytems ...
            
            if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0 | ... % %%%%
                    ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.error')) == 0)
                errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
                    'Error','modal')
                return
            else
                %The controller parameters of Lag Compensator will be calculated below
                evalin('base','[COMES_wrkspc] = LagCompensatorSynthesis(COMES_wrkspc);')
    
                %The frequency response of Plant will be calculated below.
                evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
                %The blue curve is given as the Bode Diagram of the Nominal Plant.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Magnitude (dB)')
                evalin('base','hold on')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
                xlabel('Frequency (rad/sec)')
                ylabel('Phase (deg)')
                evalin('base','hold on')
    
                %The frequency response of Loop Gain will be calculated below.
                evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
                %The red curve is given as the Bode Diagram of the Loop Gain.
                axes(handles.axes1)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
                evalin('base','hold off')
                axes(handles.axes2)
                semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
                evalin('base','hold off')
    
                %Transfer Function of controller will be appeared in the text box.   
                set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kc')),'(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau')),'s','+','1',')'))
                set(handles.text10,'string',strcat('(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.beta')),'s','+','1',')'))
            end
        end
    end
end

if evalin('base','COMES_wrkspc.convctrl.TypeOfController == 3')
    
    if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0)
        errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
            'Error','modal')
        return
    else
        %The controller parameters of PI Controller will be calculated below
        evalin('base','[COMES_wrkspc] = PDControllerSynthesis(COMES_wrkspc);')
    
        %The frequency response of Plant will be calculated below.
        evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
        %The blue curve is given as the Bode Diagram of the Nominal Plant.
        axes(handles.axes1)
        semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
        xlabel('Frequency (rad/sec)')
        ylabel('Magnitude (dB)')
        evalin('base','hold on')
        axes(handles.axes2)
        semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
        xlabel('Frequency (rad/sec)')
        ylabel('Phase (deg)')
        evalin('base','hold on')
    
        %The frequency response of Loop Gain will be calculated below.
        evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
        %The red curve is given as the Bode Diagram of the Loop Gain.
        axes(handles.axes1)
        semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
        evalin('base','hold off')
        axes(handles.axes2)
        semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
        evalin('base','hold off')
    
        %Transfer Function of controller will be appeared in the text box.
        set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kp')),'(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau_d')),'s','+','1',')'))
        set(handles.text10,'string','1')
    end
end

if evalin('base','COMES_wrkspc.convctrl.TypeOfController == 4')
    if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0)
        errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
            'Error','modal')
        return
    else
        %The controller parameters of PI Controller will be calculated below
        evalin('base','[COMES_wrkspc] = PIControllerSynthesis(COMES_wrkspc);')
    
        %The frequency response of Plant will be calculated below.
        evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
        %The blue curve is given as the Bode Diagram of the Nominal Plant.
        axes(handles.axes1)
        semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
        xlabel('Frequency (rad/sec)')
        ylabel('Magnitude (dB)')
        evalin('base','hold on')
        axes(handles.axes2)
        semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
        xlabel('Frequency (rad/sec)')
        ylabel('Phase (deg)')
        evalin('base','hold on')
        
        %The frequency response of Loop Gain will be calculated below.
        evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
        %The red curve is given as the Bode Diagram of the Loop Gain.
        axes(handles.axes1)
        semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
        evalin('base','hold off')
        axes(handles.axes2)
        semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
        evalin('base','hold off')
    
        %Transfer Function of controller will be appeared in the text box.
        set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kp')),'(','s','+',num2str(1/evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau_i')),')'))
        set(handles.text10,'string','s');
    end
end

%We will add a new approach.
% if evalin('base','convctrl.TypeOfController == 5')
%     evalin('base','[convctrl] = PIDControllerSynthesis(convctrl,System);');
% end

if evalin('base','COMES_wrkspc.convctrl.TypeOfController == 5')
    if (~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.phi')) == 0 | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.w')) == 0 ...
            | ~isempty(evalin('base','COMES_wrkspc.convctrl.InputPrm.alpha')) == 0)
        errordlg('You must firstly enter all necessary parameters to calculate the controller parameters.',...
            'Error','modal')
        return
    else
        %The controller parameters of PI Controller will be calculated below
        evalin('base','[COMES_wrkspc] = PIDControllerSynthesis(COMES_wrkspc);')
    
        %The frequency response of Plant will be calculated below.
        evalin('base','[COMES_wrkspc] = SystemFreqAnalysis(COMES_wrkspc);')
    
        %The blue curve is given as the Bode Diagram of the Nominal Plant.
        axes(handles.axes1)
        semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.SystemFRM.Gain)'),'b','LineWidth',2)
        xlabel('Frequency (rad/sec)')
        ylabel('Magnitude (dB)')
        evalin('base','hold on')
        axes(handles.axes2)
        semilogx(evalin('base','COMES_wrkspc.convctrl.SystemFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.SystemFRM.Phase*180/pi'),'b','LineWidth',2)
        xlabel('Frequency (rad/sec)')
        ylabel('Phase (deg)')
        evalin('base','hold on')
        
        %The frequency response of Loop Gain will be calculated below.
        evalin('base','[COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc);')
    
        %The red curve is given as the Bode Diagram of the Loop Gain.
        axes(handles.axes1)
        semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','20*log10(COMES_wrkspc.convctrl.LoopGainFRM.Gain)'),'r','LineWidth',2), grid on
        evalin('base','hold off')
        axes(handles.axes2)
        semilogx(evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.ffr'),evalin('base','COMES_wrkspc.convctrl.LoopGainFRM.Phase*180/pi'),'r','LineWidth',2), grid on
        evalin('base','hold off')
    
        %Transfer Function of controller will be appeared in the text box.
        set(handles.text9,'string',strcat(num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.Kp')),'(',num2str(evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau_d')),'s^2','+','s','+',num2str(1/evalin('base','COMES_wrkspc.convctrl.OutputPrm.tau_i')),')'))
        set(handles.text10,'string','s');
    end
end

% --------------------------------------------------------------------
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_2_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_3_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_4_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_5_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_6_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

evalin('base',strcat('COMES_wrkspc.convctrl.TypeOfController  =','1',';'));

%Checks for reminding of that which is used now.
set(handles.Untitled_6,'Check','On')
set(handles.Untitled_7,'Check','Off')
set(handles.Untitled_8,'Check','Off')
set(handles.Untitled_9,'Check','Off')
set(handles.Untitled_10,'Check','Off')

%
set(handles.popupmenu1,'Enable','On');
set(handles.edit3,'Enable','On');
set(handles.slider4,'Enable','Off');
set(handles.edit5,'Enable','Off');
set(handles.edit6,'Enable','Off');

% --------------------------------------------------------------------
function Untitled_7_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

evalin('base',strcat('COMES_wrkspc.convctrl.TypeOfController  =','2',';'));

%Checks for reminding of that which is used now.
set(handles.Untitled_6,'Check','Off')
set(handles.Untitled_7,'Check','On')
set(handles.Untitled_8,'Check','Off')
set(handles.Untitled_9,'Check','Off')
set(handles.Untitled_10,'Check','Off')

%
set(handles.popupmenu1,'Enable','On');
set(handles.edit3,'Enable','On');
set(handles.slider4,'Enable','Off');
set(handles.edit5,'Enable','Off');
set(handles.edit6,'Enable','Off');

% --------------------------------------------------------------------
function Untitled_8_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

evalin('base',strcat('COMES_wrkspc.convctrl.TypeOfController  =','3',';'));

%Checks for reminding of that which is used now.
set(handles.Untitled_6,'Check','Off')
set(handles.Untitled_7,'Check','Off')
set(handles.Untitled_8,'Check','On')
set(handles.Untitled_9,'Check','Off')
set(handles.Untitled_10,'Check','Off')

%
set(handles.popupmenu1,'Enable','Off');
set(handles.edit3,'Enable','Off');
set(handles.slider4,'Enable','Off');
set(handles.edit5,'Enable','Off');
set(handles.edit6,'Enable','Off');

% --------------------------------------------------------------------
function Untitled_9_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

evalin('base',strcat('COMES_wrkspc.convctrl.TypeOfController  =','4',';'));

%Checks for reminding of that which is used now.
set(handles.Untitled_6,'Check','Off')
set(handles.Untitled_7,'Check','Off')
set(handles.Untitled_8,'Check','Off')
set(handles.Untitled_9,'Check','On')
set(handles.Untitled_10,'Check','Off')

%
set(handles.popupmenu1,'Enable','Off');
set(handles.edit3,'Enable','Off');
set(handles.slider4,'Enable','Off');
set(handles.edit5,'Enable','Off');
set(handles.edit6,'Enable','Off');

% --------------------------------------------------------------------
function Untitled_10_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

evalin('base',strcat('COMES_wrkspc.convctrl.TypeOfController  =','5',';'));

%Checks for reminding of that which is used now.
set(handles.Untitled_6,'Check','Off')
set(handles.Untitled_7,'Check','Off')
set(handles.Untitled_8,'Check','Off')
set(handles.Untitled_9,'Check','Off')
set(handles.Untitled_10,'Check','On')

%
set(handles.popupmenu1,'Enable','Off');
set(handles.edit3,'Enable','Off');
set(handles.slider4,'Enable','On');
set(handles.edit5,'Enable','On');
set(handles.edit6,'Enable','On');

% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

pop_up_val1 = get(handles.popupmenu1,'Value');
pop_up_str1 = get(handles.popupmenu1,'String');

switch pop_up_str1{pop_up_val1};
    case 'Position Error'
        evalin('base',strcat('COMES_wrkspc.convctrl.InputPrm.ErrorType =','0',';'));
    case 'Velocity Error'
        evalin('base',strcat('COMES_wrkspc.convctrl.InputPrm.ErrorType =','1',';'));
    case 'Acceleration Error'
        evalin('base',strcat('COMES_wrkspc.convctrl.InputPrm.ErrorType =','2',';'));
end


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


var3 = get(handles.edit3,'String');
evalin('base',strcat('COMES_wrkspc.convctrl.InputPrm.error =',var3,';'));


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --------------------------------------------------------------------
function Untitled_13_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selection = questdlg('Do you want to restart Conventional Control Part ?',...
                     'Restart Request Function',...
                     'Yes','No','Yes');
switch selection,
   case 'Yes',
    delete(gcf)
%     evalin('base','clear all')
%     evalin('base','close all')
    evalin('base','cc_guiMainFrame')   %Buraya eklemeler yapilacak programin yeni ismi belirlenecek
   case 'No'
     return
end

% --------------------------------------------------------------------
function Untitled_14_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selection = questdlg('Do you want to close Conventional Control Part ?',...
                     'Close Request Function',...
                     'Yes','No','Yes');
switch selection,
   case 'Yes',
    delete(gcf)
    evalin('base','clear all')
    evalin('base','close all')
   case 'No'
     return
end


% --------------------------------------------------------------------
function Untitled_15_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider4_Callback(hObject, eventdata, handles)
% hObject    handle to slider4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%obtains the slider value from the slider component
sliderValue2 = get(handles.slider4,'Value');

%puts the slider value into the edit text component
set(handles.edit5,'String', num2str(sliderValue2));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function slider4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double

%get the string for the editText component
sliderValue2 = get(handles.edit5,'String');

%convert from string to number
sliderValue2 = str2num(sliderValue2);

%if user inputs something is not a number, or if the input is less than 0
%or great than 100, then the slider defaults to 0
if (isempty(sliderValue2) || sliderValue2 < 0 || sliderValue2 > 1) 
    set(handles.slider4,'Value',0);
    set(handles.edit5,'String','0');
else
    set(handles.slider4,'Value',sliderValue2);
end
guidata(hObject, handles);

var5 = get(handles.edit5,'String');
evalin('base',strcat('COMES_wrkspc.convctrl.InputPrm.alpha =',var5,';'));

% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if evalin('base','COMES_wrkspc.convctrl.TypeOfController == 1')
    %Lead Compensator Transfer Function.
    evalin('base','Gc = tf(COMES_wrkspc.convctrl.OutputPrm.Kc.*[COMES_wrkspc.convctrl.OutputPrm.tau 1],[COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.alpha 1]);')
elseif evalin('base','COMES_wrkspc.convctrl.TypeOfController == 2')
    %Lag Compensator Transfer Function.
    evalin('base','Gc = tf(COMES_wrkspc.convctrl.OutputPrm.Kc.*[COMES_wrkspc.convctrl.OutputPrm.tau 1],[COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.beta 1]);')
elseif evalin('base','COMES_wrkspc.convctrl.TypeOfController == 3')
    %PD Controller Transfer Function.
    evalin('base','Gc = tf(COMES_wrkspc.convctrl.OutputPrm.Kp.*[1 1/COMES_wrkspc.convctrl.OutputPrm.tau_i],[1 0]);') %This is wrong ...
elseif evalin('base','COMES_wrkspc.convctrl.TypeOfController == 4')
    %PI Controller Transfer Function.
    evalin('base','Gc = tf(COMES_wrkspc.convctrl.OutputPrm.Kp.*[1 1/COMES_wrkspc.convctrl.OutputPrm.tau_i],[1 0]);')
elseif evalin('base','COMES_wrkspc.convctrl.TypeOfController == 5')
    %PID Controller Transfer Function.
    evalin('base','Gc = tf(COMES_wrkspc.convctrl.OutputPrm.Kp.*[COMES_wrkspc.convctrl.OutputPrm.tau_d 1 1/COMES_wrkspc.convctrl.OutputPrm.tau_i],[1 0]);')
end

% --------------------------------------------------------------------
function Untitled_16_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
  
