
function [COMES_wrkspc] = LeadCompensatorSynthesis(COMES_wrkspc)

% Lead Compensator

phi = COMES_wrkspc.convctrl.InputPrm.phi;
wa  = COMES_wrkspc.convctrl.InputPrm.w;
Kc  = COMES_wrkspc.convctrl.InputPrm.Ks*COMES_wrkspc.convctrl.InputPrm.error;

sa  = j*wa;

Gfr = polyval(COMES_wrkspc.System.Model.numg,sa)./polyval(COMES_wrkspc.System.Model.deng,sa);

theta = 180+phi+COMES_wrkspc.System.Model.taug*wa*180/pi-angle(Kc*Gfr)*180/pi;

theta = theta-floor(theta/360)*360;

% x = 1/tau

x = sin(theta*pi/180)/(1/(Kc*abs(Gfr))-cos(theta*pi/180))*wa;

% y = 1/(alpha*tau)

y = sin(theta*pi/180)/(cos(theta*pi/180)-Kc*abs(Gfr))*wa;

COMES_wrkspc.convctrl.OutputPrm.tau   = 1/x;

COMES_wrkspc.convctrl.OutputPrm.alpha = x/y;

COMES_wrkspc.convctrl.OutputPrm.Kc    = Kc;

% End of Function (Lag Compensator)