
function [COMES_wrkspc] = LoopGainFreqAnalysis(COMES_wrkspc)

ffr = logspace(-2,4,5000);

if COMES_wrkspc.convctrl.TypeOfController == 1
    
    Gfr=polyval(conv(COMES_wrkspc.convctrl.OutputPrm.Kc.*[COMES_wrkspc.convctrl.OutputPrm.tau 1],COMES_wrkspc.System.Model.numg),j.*ffr)./polyval(conv([COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.alpha 1],COMES_wrkspc.System.Model.deng),j.*ffr).*exp(-COMES_wrkspc.System.Model.taug.*j.*ffr);
    
    elseif COMES_wrkspc.convctrl.TypeOfController == 2
    
    Gfr=polyval(conv(COMES_wrkspc.convctrl.OutputPrm.Kc.*[COMES_wrkspc.convctrl.OutputPrm.tau 1],COMES_wrkspc.System.Model.numg),j.*ffr)./polyval(conv([COMES_wrkspc.convctrl.OutputPrm.tau*COMES_wrkspc.convctrl.OutputPrm.beta 1],COMES_wrkspc.System.Model.deng),j.*ffr).*exp(-COMES_wrkspc.System.Model.taug.*j.*ffr);
    
    elseif COMES_wrkspc.convctrl.TypeOfController == 3
    
    Gfr=polyval(conv(COMES_wrkspc.convctrl.OutputPrm.Kp.*[COMES_wrkspc.convctrl.OutputPrm.tau_d 1],COMES_wrkspc.System.Model.numg),j.*ffr)./polyval(conv([1],COMES_wrkspc.System.Model.deng),j.*ffr).*exp(-COMES_wrkspc.System.Model.taug.*j.*ffr);
    
    elseif COMES_wrkspc.convctrl.TypeOfController == 4
    
    Gfr=polyval(conv(COMES_wrkspc.convctrl.OutputPrm.Kp.*[1 1/COMES_wrkspc.convctrl.OutputPrm.tau_i],COMES_wrkspc.System.Model.numg),j.*ffr)./polyval(conv([1 0],COMES_wrkspc.System.Model.deng),j.*ffr).*exp(-COMES_wrkspc.System.Model.taug.*j.*ffr);
    
    elseif COMES_wrkspc.convctrl.TypeOfController == 5
    
    Gfr=polyval(conv(COMES_wrkspc.convctrl.OutputPrm.Kp.*[COMES_wrkspc.convctrl.OutputPrm.tau_d 1 1/COMES_wrkspc.convctrl.OutputPrm.tau_i],COMES_wrkspc.System.Model.numg),j.*ffr)./polyval(conv([1 0],COMES_wrkspc.System.Model.deng),j.*ffr).*exp(-COMES_wrkspc.System.Model.taug.*j.*ffr);
    
end

COMES_wrkspc.convctrl.LoopGainFRM.ffr   = ffr;
COMES_wrkspc.convctrl.LoopGainFRM.Gain  = abs(Gfr);
COMES_wrkspc.convctrl.LoopGainFRM.Phase = unwrap(angle(Gfr));

%End Of Function