
function [COMES_wrkspc] = PIControllerSynthesis(COMES_wrkspc)

% PI Controller

phi = COMES_wrkspc.convctrl.InputPrm.phi;
wa  = COMES_wrkspc.convctrl.InputPrm.w;

sa  = j*wa;

Gfr = polyval(COMES_wrkspc.System.Model.numg,sa)./polyval(COMES_wrkspc.System.Model.deng,sa);

theta = 180+phi+COMES_wrkspc.System.Model.taug*wa*180/pi-angle(Gfr)*180/pi;

theta = theta-floor(theta/360)*360;

% x = Ki

x = -wa*sin(theta*pi/180)/abs(Gfr);

% y = Kp

y = cos(theta*pi/180)/abs(Gfr);

COMES_wrkspc.convctrl.OutputPrm.Kp = y;

COMES_wrkspc.convctrl.OutputPrm.tau_i = y/x;

% End Of Function (PI Controller)