
function [COMES_wrkspc] = PIDControllerSynthesis(COMES_wrkspc)

% PID Controller

phi   = COMES_wrkspc.convctrl.InputPrm.phi;
wa    = COMES_wrkspc.convctrl.InputPrm.w;
alpha = COMES_wrkspc.convctrl.InputPrm.alpha;

sa  = j*wa;

Gfr = polyval(COMES_wrkspc.System.Model.numg,sa)./polyval(COMES_wrkspc.System.Model.deng,sa);

theta = 180+phi+COMES_wrkspc.System.Model.taug*wa*180/pi-angle(Gfr)*180/pi;

theta = theta-floor(theta/360)*360;

% x = Ki

x = wa*sin(theta*pi/180)/abs(Gfr)/(alpha*wa^2-1);

% y = Kp

y = cos(theta*pi/180)/abs(Gfr);

% z = Kd

z = alpha*x;

COMES_wrkspc.convctrl.OutputPrm.Kp    = y;

COMES_wrkspc.convctrl.OutputPrm.tau_i = y/x;

COMES_wrkspc.convctrl.OutputPrm.tau_d = z/y;

% End Of Function (PID Controller)