%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Initialize the program                        %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% clear all
% close all
% clc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Enter the transfer function of digital system %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
num=[0.06 0.034 0.071];                 %numerator
den=[1 -0.606 -0.747 0.519 0 0 0 0];    %denominator
Ts=0.01;                                %sampling time
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Normalize the transfer function               %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
K=num(1)/den(1);                        %static gain
num_Gfb=num/num(1);                     %numerator
den_Gfb=den/den(1);                     %denominator
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Now we will find the non-minimum phase zeros  %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
roots_numGfb=roots(num_Gfb)';
roots_denGfb=roots(den_Gfb)';

num_mp=1;       num_nmp=1;
roots_mp=[];    roots_nmp=[];
mp=0;           nmp=0;

for i=1:(length(num)-1)
    if abs(roots_numGfb(i))>1
        nmp=nmp+1;
        roots_nmp(nmp)=roots_numGfb(i);
        num_nmp=conv(num_nmp,[1 -roots_numGfb(i)]);
    else
        mp=mp+1;
        roots_mp(mp)=roots_numGfb(i);
        num_mp=conv(num_mp,[1 -roots_numGfb(i)]);
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Now we will find the real and complex         %%% 
%%% non-minimum phase zeros                       %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
roots_nmp_re = [];      roots_nmp_im = []; 
nmp_re=0;               nmp_im=0;

if isempty(roots_nmp) ~= 1
    for i=1:nmp
        if imag(roots_nmp(i)) == 0
            nmp_re = nmp_re + 1;
            roots_nmp_re(nmp_re) = roots_nmp(i);
        else
            nmp_im = nmp_im + 1;
            roots_nmp_im(nmp_im) = roots_nmp(i);
        end       
    end
end


