%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Choose the desired bandwidth of feedforward   %%%
%%% compensator                                   %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
theta=linspace(0,pi/2,1000);
z = exp(j*theta);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Choose the amount of non-minimum phase zeros  %%%
%%% (real and complex)                            %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sol_re = 2;
sol_im = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Choose a weighting function                   %%%
%%% (real and complex)                            %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
num_wth = [3.61];
den_wth = conv([1 0.9],[1 0.9]);

Wth = polyval(num_wth,z)./polyval(den_wth,z);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%yapilacak optimizasyon isleminde kullanilacak parametre degerleri
m=10;                       %paralel islenecek zm aday kmesi.
n=sol_re+sol_im;			%parametre sayisi veya zm aday vektrlerinin boyutu.
stopcr=1000; 				%durma kriteri. Aramayi en fazla ka adim yapacagini belirler..
maxdenx=10;                 %10 bagimsiz deneme yapacak.
nbit=16;					%parametredeki bit sayisi.
maxval=1;                   %her parametrenin alacagi maksimum deger.
minval=-1;                  %her parametrenin alacagi minimum deger.

kusa=2^nbit;				%kuanta sayisi
scl=(maxval-minval)/kusa;			%normalizasyon parametresi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Big Bang Big Crunch Optimization Routine      %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%evrimsel algoritmada kullanilacak ilk nesil programa giriliyor.
ilkbirey = kusa.*[rand(m,sol_re) rand(m,2*sol_im)];

%Sphere fonksiyonu iin iyilesme grafigindeki referans iin cost0 hesaplanir.
for birey_no=1:m,
    cost0(birey_no)=MagCost2(K,num_nmp,roots_nmp_re,roots_nmp_im,sol_re,sol_im,minval+scl.*ilkbirey(birey_no,:),z,Wth);
    cost0(birey_no)=abs(cost0(birey_no));
end

[eniyi,j] = min(cost0);		%butun denemelerdeki eniyiyi tutmak icin burada resetlendi...
bireyopt = ilkbirey(j,:);
%-------------------------

for deneme=1:maxdenx,
    
eniyi=min(cost0);		%referans eniyi degeri
birey=ilkbirey;
iterval(deneme)=0;
tic                         %Zamanlayiciyi baslat
%*******************************************************************
for itersa=1:stopcr,		%Dnglerin baslangici

	%***************cost function degerlerinin bulunmasi**************
   sumcosts=0;
   for birey_no=1:m,
      costs(birey_no)=MagCost2(K,num_nmp,roots_nmp_re,roots_nmp_im,sol_re,sol_im,minval+scl.*birey(birey_no,:),z,Wth);
      costs(birey_no)=abs(costs(birey_no));
      if costs(birey_no)<eniyi
         eniyi=costs(birey_no);
         bireyopt=birey(birey_no,:);
      end
      sumcosts = sumcosts + 1/(costs(birey_no)+0.0001);  	
   end

   % Yaklasim islemi
   for parametre_no=1:n,
      ortanokta(parametre_no)=0;
      for birey_no=1:m,
         ortanokta(parametre_no)=ortanokta(parametre_no)+birey(birey_no,parametre_no)*(1/(costs(birey_no)+0.0001));	
      end
      ortanokta(parametre_no)=floor((1/sumcosts)*ortanokta(parametre_no));
   end

   % Dagitim islemi (ortanokta etrafinda normal dagilmis yeni noktalar turetir)
   for birey_no=1:m-1,
      for parametre_no=1:n,
%         sapma=floor((kusa-1)*randn(1)*(1/itersa));
         sapma=floor((kusa-1)*randn(1));
         yeni_parametre=ortanokta(parametre_no)+sapma;
         if yeni_parametre>=kusa
            yeni_parametre = kusa-1;
         end
         if yeni_parametre<0
            yeni_parametre = 0;
         end
         birey(birey_no,parametre_no) = yeni_parametre;
      end
   end
sonuc(deneme,itersa)=eniyi;
end							%Dongulerin sonu
tspan(deneme)=toc;          %Zamanlayiciyi durdur
end							%Bagimsiz denemelerin sonu

%raporlama
% [sonuc,iterval,tspan]=chauvenet(sonuc,iterval,tspan); %Chauvenet kriterini uygulayarak sonucu duzeltiyoruz. 
ortalama = mean(sonuc);
% stdspm   = std(sonuc(:,length(sonuc)))
% CPUtime  = mean(tspan)
% funceval = mean(iterval)
figure(2)
plot(ortalama)
xlabel('iteration')
ylabel('fitness value')
cozum_yeni = minval+scl.*bireyopt
%eniyi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Choose the desired bandwidth of feedforward   %%%
%%% compensator                                   %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
