%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Initialize the program                        %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
% close all
clc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Enter the transfer function of digital system %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
num = [0.0344  -0.0156  -0.0348    0.0188];
den = [1.0000  -3.6691    6.3539  -6.8894    4.9048  -2.2109    0.5809  -0.0673]+[0 0 0 0 0.0344  -0.0156  -0.0348    0.0188];
% num=[0.06 0.034 0.071];                 %numerator
% den=[1 -0.606 -0.747 0.519 0 0 0 0];    %denominator
Ts=0.0002;                                %sampling time
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Normalize the transfer function               %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
K=num(1)/den(1);                        %static gain 
num_Gfb=num/num(1);                     %numerator
den_Gfb=den/den(1);                     %denominator
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Now we will find the non-minimum phase zeros  %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
roots_numGfb=roots(num_Gfb)';
roots_denGfb=roots(den_Gfb)';

num_mp=1;       num_nmp=1;
roots_mp=[];    roots_nmp=[];
mp=0;           nmp=0;

for i=1:(length(num)-1)
    if abs(roots_numGfb(i))>1
        nmp=nmp+1;
        roots_nmp(nmp)=roots_numGfb(i);
        num_nmp=conv(num_nmp,[1 -roots_numGfb(i)]);
    else
        mp=mp+1;
        roots_mp(mp)=roots_numGfb(i);
        num_mp=conv(num_mp,[1 -roots_numGfb(i)]);
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Now we will find the real and complex         %%% 
%%% non-minimum phase zeros                       %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
roots_nmp_re = [];      roots_nmp_im = []; 
nmp_re=0;               nmp_im=0;

if isempty(roots_nmp) ~= 1
    for i=1:nmp
        if imag(roots_nmp(i)) == 0
            nmp_re = nmp_re + 1;
            roots_nmp_re(nmp_re) = roots_nmp(i);
        else
            nmp_im = nmp_im + 1;
            roots_nmp_im(nmp_im) = roots_nmp(i);
        end       
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Choose the desired bandwidth of feedforward   %%%
%%% compensator                                   %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
theta=linspace(0,pi/2,1000);
z = exp(j*theta);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Choose the amount of non-minimum phase zeros  %%%
%%% (real and complex)                            %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sol_re = 2;
sol_im = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Choose a weighting function                   %%%
%%% (real and complex)                            %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
num_wth = [3.61];
den_wth = conv([1 0.9],[1 0.9]);
Wth = polyval(num_wth,z)./polyval(den_wth,z);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nbit=16;					%parametredeki bit sayisi
maxval=1;                  %her parametrenin alacagi maksimum deger.
minval=-1;

kusa=2^nbit;				%kuanta sayisi
scl=(maxval-minval)/kusa;			%normalizasyon parametresi

x_0 = kusa.*[rand(1,sol_re) rand(1,2*sol_im)];

s_0=minval+scl.*x_0

% s_0 = [rand(1,sol_re) rand(1,2*sol_im)]

% s_0 = [0.3947 -0.9452]
% 
% s_0 = [rand(1,sol_re) rand(1,2*sol_im)]

% s_0 = [0.5949 0.7492]

% s_0 = [0.3947 -0.9452]

% s_0=[0.2061    0.3836]

% s_0=[-1.0000    0.2202    0.5275    0.3677]
% 
% s_0=[0.2596   -0.1045    0.2171    0.08180]

% s_0=[-1.0000   -0.8503    0.5290   -0.2899]

% s_0=[0.6598   -0.3576    0.4666    0.6020]


% s_0=[0.4525   -0.9855]

% s_0=[0.1815    0.2548]

% s_0=[0.3300   -0.0091]

% s_0=[0.2363    0.1861]

% s_0=[0.1935    0.2532]

% s_0=[0.2816    0.1025]

% s_0=[0.2578    0.2029]
% 
% s_0=[0.1943    0.2630]

s_0=[0.0309    0.1274]

s_0=[0.0527    0.1391]

s_0=[0.1070    0.0896]

[y]=MagCost2(K,num_nmp,roots_nmp_re,roots_nmp_im,sol_re,sol_im,s_0,z,Wth)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Simulated Annealing Optimization Routine      %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% tic
% %The frequency response of plant (digital)
% Gfr=abs(polyval(num,z)./polyval(den,z)); 
% %neighbourhood structure for the solution space
% N = @(x) (x+(randperm(length(x))==length(x))*randn/100);
% alpha = @(t) (.8*t);                %cooling schdules
% 
% for deneme = 1:1
%     
% t_0 = 1e25;                                 %initial temperature
% t = t_0;                                    %current temperature
% 
% %Choose the initial solution candidate randomly
% s_0 = [rand(1,sol_re) rand(1,2*sol_im)];
% 
% % f = frekans4(K,num_mp,roots_nmp_re,roots_nmp_im,den_Gfb,s_0,w,Gfr);                            %cost function
% % iter = 1;                                   %initial iteration
% % minF(deneme,iter) = f;
% iter = 0;
% 
% for i = 1:inf
%     for k = 1:200
%         iter = iter + 1;            %counter
%         s = N(s_0);                 %neighbourhood
%         f1 = frekans4(K,num_mp,roots_nmp_re,roots_nmp_im,den_Gfb,sol_re,sol_im,s,z,Gfr);
%         f2 = frekans4(K,num_mp,roots_nmp_re,roots_nmp_im,den_Gfb,sol_re,sol_im,s_0,z,Gfr);
%         diff = f1 - f2; %difference of energy
%         minF(deneme,iter) = f1;
%         %
%         if diff < 0
%             s_0 = s;
%         else 
%             x = rand(1);
%             if x > exp(-diff/t)
%                 s_0 = s;
%             end
%         end
%         %maximum number of iteration
%         if iter == 2000
%             break
%         end
%     end
%     t = alpha(t);                   %cooling schedules
%     %stopping condition
%     if t <= 1e-1 % 1e-3
%         break
%     end
%     %maximum number of iteration
%     if iter == 2000
%         break
%     end
% end
% sonuc(deneme) = frekans4(K,num_mp,roots_nmp_re,roots_nmp_im,den_Gfb,sol_re,sol_im,s_0,z,Gfr);
% end
% toc
% 
% sonuc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Choose the desired bandwidth of feedforward   %%%
%%% compensator                                   %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




