%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ActuatorEval.m 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Calculates the frequency magnitude response of actuator transfer
%   function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   inputs :
%       fa      : frequency of computation (scalar)
%       numg    :
%       deng    :
%
%   outputs :
%       Gr      : Real part of the plant at frequency 'fa' (scalar)
%       Gi      : Imaginary part of the plant at frequency 'fa' (scalar)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [COMES_wrkspc] = PlantEval(COMES_wrkspc)

num=COMES_wrkspc.System.Model.numg;
den=COMES_wrkspc.System.Model.deng;
fa=COMES_wrkspc.mdlrgltr.InputPrm.f;

wa = 2*pi*fa;
sa = j*wa;
G=polyval(numg,sa)./polyval(deng,sa);
COMES_wrkspc.mdlrgltr.InputPrm.Gr=real(G);
COMES_wrkspc.mdlrgltr.InputPrm.Gi=imag(G);

%End Of Function