%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% WsWtEval.m 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Calculates the 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   inputs :
%       fa      : frequency of computation (scalar)
%       numws   : 
%       denws   :
%       numwt   :
%       denwt   :
%
%   outputs :
%       Wt      : absolute values of Wt (vector)
%       Ws      : absolute values of Ws (vector)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [COMES_wrkspc] = WsWtEval(COMES_wrkspc)

numws=COMES_wrkspc.mdlrgltr.SensPrm.numws;
denws=COMES_wrkspc.mdlrgltr.SensPrm.denws;
numwt=COMES_wrkspc.mdlrgltr.SensPrm.numwt;
denwt=COMES_wrkspc.mdlrgltr.SensPrm.denwt;

fa=COMES_wrkspc.mdlrgltr.InputPrm.f;

wa = 2*pi*fa;
sa=j*wa;

Ws=polyval(numws,sa)./polyval(denws,sa);
COMES_wrkspc.mdlrgltr.SensFRM.Ws=abs(Ws);

Wt=polyval(numwt,sa)./polyval(denwt,sa);
COMES_wrkspc.mdlrgltr.SensFRM.Wt=abs(Wt);

%End Of Function