
function [COMES_wrkspc] = DRegionMap(COMES_wrkspc)


% Parametres
% -------------------------------------------------------------------------
sigma=COMES_wrkspc.rbstctrl.DStability.Constraints.sigma;
alpha=COMES_wrkspc.rbstctrl.DStability.Constraints.alpha*pi/180;
R=COMES_wrkspc.rbstctrl.DStability.Constraints.R;

% Transferfunction of plant
num_p=COMES_wrkspc.System.Model.numg;
den_p=COMES_wrkspc.System.Model.deng;

% Transfer function of controller
num_c=subs(COMES_wrkspc.rbstctrl.Controller.Model.num,{COMES_wrkspc.rbstctrl.Controller.Label.x1,COMES_wrkspc.rbstctrl.Controller.Label.x2},{sym('x1','real'),sym('x2','real')});
den_c=subs(COMES_wrkspc.rbstctrl.Controller.Model.den,{COMES_wrkspc.rbstctrl.Controller.Label.x1,COMES_wrkspc.rbstctrl.Controller.Label.x2},{sym('x1','real'),sym('x2','real')});

syms s w r theta x1 x2 real

G=poly2sym(num_p,s)/poly2sym(den_p,s);

C=poly2sym(num_c,s)/poly2sym(den_c,s);

L=C*G;

T=simplify(L/(1+L));

[N,D]=numden(T);

% -------------------------------------------------------------------------

[tn,tq]=ginput(1);


COMES_wrkspc.rbstctrl.DStability.DRegion.g1=-sigma*ones(1,1000)+j*linspace(0,sigma*tan(pi-alpha),1000);


COMES_wrkspc.rbstctrl.DStability.DRegion.g2=linspace(-sigma,real(R*exp(j*alpha)),1000)+j*linspace(sigma*tan(pi-alpha),imag(R*exp(j*alpha)),1000);


theta=linspace(alpha,pi+(pi-alpha));

COMES_wrkspc.rbstctrl.DStability.DRegion.g3=R.*exp(j*theta);


COMES_wrkspc.rbstctrl.DStability.DRegion.g1n=-sigma*ones(1,1000)-j*linspace(0,sigma*tan(pi-alpha),1000);


COMES_wrkspc.rbstctrl.DStability.DRegion.g2n=linspace(-sigma,real(R*exp(j*alpha)),1000)-j*linspace(sigma*tan(pi-alpha),imag(R*exp(j*alpha)),1000);


COMES_wrkspc.rbstctrl.DStability.DRegion.root=double(solve(subs(D,{'x1','x2'},{tn,tq})));

% End Of Function


