
function [COMES_wrkspc] = GainMarginCalc(COMES_wrkspc)

% Desired gain range
gain = linspace(COMES_wrkspc.rbstctrl.GainMargin.Options.StrGain,COMES_wrkspc.rbstctrl.GainMargin.Options.EndGain,COMES_wrkspc.rbstctrl.GainMargin.Options.GridGain);

% Frequency range
f = linspace(COMES_wrkspc.rbstctrl.GainMargin.Options.StrFrq,COMES_wrkspc.rbstctrl.GainMargin.Options.EndFrq,COMES_wrkspc.rbstctrl.GainMargin.Options.GridFrq);

% Transferfunction of plant
num_p=COMES_wrkspc.System.Model.numg;
den_p=COMES_wrkspc.System.Model.deng;

% Transfer function of controller
num_c=subs(COMES_wrkspc.rbstctrl.Controller.Model.num,{COMES_wrkspc.rbstctrl.Controller.Label.x1,Controller.Label.x2},{sym('x1','real'),sym('x2','real')});
den_c=subs(COMES_wrkspc.rbstctrl.Controller.Model.den,{COMES_wrkspc.rbstctrl.Controller.Label.x1,Controller.Label.x2},{sym('x1','real'),sym('x2','real')});

% -------------------------------------------------------------------------

syms s w r theta x1 x2 real

G=poly2sym(num_p,s)/poly2sym(den_p,s);

C=poly2sym(num_c,s)/poly2sym(den_c,s);

L=C*G;

Lfr=simplify(subs(L,'s',j*w));

for i=1:length(gain)
    
    eqn1 = simplify(real(Lfr))+gain(i);
    
    eqn2 = simplify(imag(Lfr))+0;
    
    sol=solve(eqn1, eqn2, 'x1','x2');
    
    COMES_wrkspc.rbstctrl.GainMargin.Solutions.x1(i,:)=subs(sol.x1,'w',f);
    
    COMES_wrkspc.rbstctrl.GainMargin.Solutions.x2(i,:)=subs(sol.x2,'w',f);
    
end

% End Of Function
